---
title: Building Platforms with empathy and yaml at the lego group
weight: 14
tags:
 - platform
 - cloudnativecon
---

{{% button href="https://youtu.be/8FmJWd7vRt4" style="warning" icon="video" %}}Watch talk on YouTube{{% /button %}}
<!-- {{% button href="https://docs.google.com/presentation/d/1nEK0CVC_yQgIDqwsdh-PRihB6dc9RyT-" style="tip" icon="person-chalkboard" %}}Slides{{% /button %}} -->

Very nice kids playing with lego intro analogy about creativity, sharing and colaboration.

## The golden brick

- The brick could get picked up and sometimes picking it up is mandatory
- Devemopment in close colab and trust with users
- Focus on good enough instead of perfect but everyone is unhapy

### Guidelines

- API first: Define a speration beween users and services with abstractions
- Self services: Freedom of choice and combination
- Constraints that are soft and can be modified on feedback

### Offers

- Kubernetes as a service
- Runtime as a Service: NAmespace as a service with argo and without cluster access
    - Problem: Users want kubeapi access
    - Method: Talk with the users
    - Solution: Zero Trust proxy that provides operational access to kubeapi via OIDC
- There are multiple APIs that can be combined -> You need constraints

### What's needed

- Conversation
- Trust
- Striking a balance

## The human aspect

- Treat people as colleagues instead of customers
- Build empathy to reach a ballanced "good enough"
- Lead with transparency: Publish your metrics
- Visit their context
- Explore unknowns together
- Create a shared understanding of challenges

### Team culture

- Know who you are helping an who helps you
- Empower them to shine by getting to know their context
- Hear them out in small meetings ore in person

## Platform maturity

TODO: Steal maturity chart